# -*- coding: utf-8 -*-
"""
Created on Tue Jan  2 11:52:00 2018

@author: Utilisateur
"""
import tkinter as tk
from tkinter.filedialog import askopenfilename
#import matplotlib.pyplot as plt
#from mpl_toolkits.mplot3d.axes3d import Axes3D, get_test_data
#from matplotlib import cm
#import numpy as np
from time import time
#import psutil
#pid=os.getpid()
#ps=psutil.Process(pid)
from tkinter import ttk
from tkinter import messagebox
#import pygame
#from pygame.locals import *
#from time import sleep
#import os
#import random
#import gc
from modelediscret import *
from modelecontinu import *


class Fenetre(tk.Tk):
    def __init__(self,continu=False):
        self.continu=continu
        self.pop="populationfrance1998_2016.csv"
        self.mort="mortalitefrance1998_2015.csv"
        self.fec="feconditefrance1998_2015.csv"
        self.em="emigrationfrance1998_2015.csv"
        self.im="immigrationfrance1998_2015.csv"
        self.p=100
        self.annee=2007
        self.dt=1
        self.K=float("inf")
        tk.Tk.__init__(self)
        self.title("Leslie "+("continu" if continu else "discret")+" | Dubard, Alcaraz, Monier")
        self.partie1=tk.Frame(self,borderwidth=2,relief=tk.GROOVE)
        self.partie1.pack(side=tk.LEFT)
        self.partie2=tk.Frame(self,borderwidth=2,relief=tk.GROOVE)
        self.partie2.pack(side=tk.LEFT)
        #Partie1
        self.frame11=tk.Frame(self.partie1,borderwidth=2)
        self.frame11.pack(padx=10,pady=10)
        self.frame21=tk.Frame(self.partie1,borderwidth=2)
        self.frame21.pack(padx=10,pady=10)
        self.frame31=tk.Frame(self.partie1,borderwidth=2)
        self.frame31.pack(padx=10,pady=10)
        self.frame41=tk.Frame(self.partie1,borderwidth=2)
        self.frame41.pack(padx=10,pady=10)
        self.frame51=tk.Frame(self.partie1,borderwidth=2)
        self.frame51.pack(padx=10,pady=10)
        #partie2
        self.frame0=tk.Frame(self.partie2,borderwidth=2,relief=tk.GROOVE)
        self.frame0.pack(padx=10,pady=10)
        self.frame1=tk.Frame(self.partie2,borderwidth=2,relief=tk.GROOVE)
        self.frame1.pack(padx=10,pady=10)
        self.frame2=tk.Frame(self.partie2,borderwidth=2,relief=tk.GROOVE)
        self.frame2.pack(padx=10,pady=10)
        self.frame3=tk.Frame(self.partie2,borderwidth=2,relief=tk.GROOVE)
        self.frame3.pack(padx=10,pady=10)
        #
        tk.Label(self.frame11,text="fichier population initiale").pack()
        tk.Label(self.frame21,text="fichier mortalité").pack()
        tk.Label(self.frame31,text="fichier fécondité").pack()
        tk.Label(self.frame41,text="fichier emigration").pack()
        tk.Label(self.frame51,text="fichier immigration").pack()
        self.fichier1=tk.Entry(self.frame11,width=50);self.fichier1.pack(side=tk.LEFT)
        self.fichier1.insert(0,self.pop)
        self.fichier2=tk.Entry(self.frame21,width=50);self.fichier2.pack(side=tk.LEFT)
        self.fichier2.insert(0,self.mort)
        self.fichier3=tk.Entry(self.frame31,width=50);self.fichier3.pack(side=tk.LEFT)
        self.fichier3.insert(0,self.fec)
        self.fichier4=tk.Entry(self.frame41,width=50);self.fichier4.pack(side=tk.LEFT)
        self.fichier4.insert(0,self.em)
        self.fichier5=tk.Entry(self.frame51,width=50);self.fichier5.pack(side=tk.LEFT)
        self.fichier5.insert(0,self.im)
        #
        self.bouton1=tk.Button(self.frame11,text="parcourir",command=self.bouton1fct);self.bouton1.pack(side=tk.BOTTOM)
        self.bouton2=tk.Button(self.frame21,text="parcourir",command=self.bouton2fct);self.bouton2.pack(side=tk.BOTTOM)
        self.bouton3=tk.Button(self.frame31,text="parcourir",command=self.bouton3fct);self.bouton3.pack(side=tk.BOTTOM)
        self.bouton4=tk.Button(self.frame41,text="parcourir",command=self.bouton4fct);self.bouton4.pack(side=tk.BOTTOM)
        self.bouton5=tk.Button(self.frame51,text="parcourir",command=self.bouton5fct);self.bouton5.pack(side=tk.BOTTOM)
        #
        self.v=tk.BooleanVar()
        tk.Radiobutton(self.partie2,text="continu",variable=self.v,value=True,command=self.log).pack()
        tk.Radiobutton(self.partie2,text="discret",variable=self.v,value=False,command=self.log).pack()
        #
        self.entree2=tk.Entry(self.frame1)
        self.entree2.insert(0,str(self.p))
        self.labelpasdetemps=tk.Label(self.frame0,text="Pas de temps dt : ")
        self.entree0=tk.Entry(self.frame0)
        self.entree0.insert(0,str(self.dt))
        self.paslist=ttk.Combobox(self.frame0)
        self.paslist["values"]=("ans","mois","jours","heure","minute","seconde")
        self.paslist.current(0)
        self.labelnbclasses=tk.Label(self.frame1,text="nb de classes d'âges : ")
        if continu:
            self.labelpasdetemps.pack(side=tk.LEFT)
            self.entree0.pack(side=tk.LEFT)
            self.paslist.pack(side=tk.LEFT)
            self.labelnbclasses.pack(side=tk.LEFT)
            self.entree2.pack(side=tk.LEFT)

        tk.Label(self.frame2,text="entrez l'année initiale :").pack(side=tk.LEFT)
        self.entree1=tk.Entry(self.frame2);self.entree1.pack(side=tk.LEFT)
        self.entree1.insert(0,str(self.annee))
        tk.Label(self.frame3,text="temps max :").pack(side=tk.LEFT)
        self.nentry=tk.Entry(self.frame3);self.nentry.pack(side=tk.LEFT)
        self.immigration_check_var=tk.BooleanVar()
        self.emmigration_check_var=tk.BooleanVar()

        tk.Checkbutton(self.frame3,var=self.immigration_check_var,text="sans immigration").pack()
        tk.Checkbutton(self.frame3,var=self.emmigration_check_var,text="sans emmigration").pack()
        self.rencontre_check_var=tk.BooleanVar()
        self.rencontrecheckbonton=tk.Checkbutton(self.frame3,var=self.rencontre_check_var,text="avec probabilité de rencontre")
        if continu:
            self.rencontrecheckbonton.pack()
        self.logistique_check_var=tk.BooleanVar()
        tk.Checkbutton(self.frame3,var=self.logistique_check_var,text="avec seuil logistique",command=self.log).pack()
        #
        self.logframe=tk.Frame(self.frame3)
        self.logframe.pack()
        self.loglabel=tk.Label(self.logframe,text="seuil de population : ")
        self.logentry=tk.Entry(self.logframe)
        self.logentry.insert(0,str(self.K))
        #
        self.Bouton=tk.Button(self.frame3,text="Tracer",command=self.callback);self.Bouton.pack()
        #
        self.mainloop()

    def log(self):
        if self.logistique_check_var.get():
            self.loglabel.pack(side=tk.LEFT)
            self.logentry.pack(side=tk.LEFT)
        else:
            self.loglabel.pack_forget()
            self.logentry.pack_forget()
        self.continu=self.v.get()
        if self.continu:
            self.labelpasdetemps.pack(side=tk.LEFT)
            self.entree0.pack(side=tk.LEFT)
            self.paslist.pack(side=tk.LEFT)
            self.labelnbclasses.pack(side=tk.LEFT)
            self.entree2.pack(side=tk.LEFT)
            self.rencontrecheckbonton.pack()
        else:
            self.labelpasdetemps.pack_forget()
            self.entree0.pack_forget()
            self.paslist.pack_forget()
            self.labelnbclasses.pack_forget()
            self.entree2.pack_forget()
            self.rencontrecheckbonton.pack_forget()

    def parcourir(self):
        filename =askopenfilename(parent = self,filetypes=(("csv files","*.csv"),("All files","*.*")),title = 'Veuillez entrer un nom de fichier ')
        return filename
    def bouton1fct(self):
        self.pop=self.parcourir()
        self.fichier1.delete(0,tk.END)
        self.fichier1.insert(0,self.pop)
    def bouton2fct(self):
        self.mort=self.parcourir()
        self.fichier2.delete(0,tk.END)
        self.fichier2.insert(0,self.mort)
    def bouton3fct(self):
        self.fec=self.parcourir()
        self.fichier3.delete(0,tk.END)
        self.fichier3.insert(0,self.fec)
    def bouton4fct(self):
        self.em=self.parcourir()
        self.fichier4.delete(0,tk.END)
        self.fichier4.insert(0,self.em)
    def bouton5fct(self):
        self.im=self.parcourir()
        self.fichier5.delete(0,tk.END)
        self.fichier5.insert(0,self.im)

    def callback(self):
#        try:
        ti=time()
        self.annee=int(self.entree1.get())
        n=int(self.nentry.get())
        self.p=int(self.entree2.get())
        self.K=float(self.logentry.get())
        if self.continu:
            self.dt=float(self.entree0.get())/({"ans":1,"mois":12,"jours":365,"heure":365*24,"minute":365*24*60,"seconde":365*24*60*60}[self.paslist.get()])

        #
        initiale,mortalite,fecondite,emmigration,immigration,fichierpopulationinitiale,femmes,mortalitehomme,mortalitefemme,hommes,immigrationhomme,immigrationfemme,emmigrationhomme,emmigrationfemme,fichierfemme,fichierhomme=ouverturefichier(self.pop,self.mort,self.fec,self.em,self.im,self.annee)
        if self.immigration_check_var.get():
            print("!!! on ne prends pas en compte l'immigration")
            immigration=[0 for i in range(len(immigration))]
            immigrationhomme=[0 for i in range(len(immigration))]
            immigrationfemme=[0 for i in range(len(immigration))]
        if self.emmigration_check_var.get():
            print("!!! on ne prends pas en compte l'emmigration")
            emmigration=[0 for i in range(len(emmigration))]
            emmigrationhomme=[0 for i in range(len(emmigration))]
            emmigrationfemme=[0 for i in range(len(emmigration))]
        survie=matsurvie(mortalite,emmigration)
        if self.continu:
            resultat,yliste,yliste2,ecartliste,ecartlistetot,arret=continu(self.dt,self.p,hommes,femmes,fecondite,mortalitehomme,mortalitefemme,immigrationhomme,immigrationfemme,emmigrationhomme,emmigrationfemme,n,self.annee,fichierpopulationinitiale,fichierhomme,fichierfemme,logistique=self.logistique_check_var.get(),K=self.K,rencontre=self.rencontre_check_var.get())
            tracer(n,yliste,yliste2,ecartliste,ecartlistetot,arret,ti,hs)
        else:
            resultat,yliste,yliste2,ecartliste,ecartlistetot,arret=matriciel(matrice(initiale),Leslie(fecondite,survie),matimmigration(immigration),n,self.annee,fichierpopulationinitiale,logistique=self.logistique_check_var.get(),K=self.K)
        #print("[+] population au pas de temps "+str(n)+" : \n",resultat)
#            tot=0
#            for i in range(len(resultat)):#complexité : O(n)
#                tot+=resultat[i][0]
        #print("[+] population totale au pas de temps "+str(n)+" : ",tot)
            enregistrement(tableau(yliste,yliste2,ecartliste,ecartlistetot,n,annee))
            tracer(n,yliste,yliste2,ecartliste,ecartlistetot,arret,ti)
#        except IndexError as erreur:
#            messagebox.showerror("erreur","Veuillez modifiez le paramètre (ou le script :))\n"+str(erreur)+"\n"+str(erreur.args))


if __name__=="__main__":
    F=Fenetre()
