# -*- coding: utf-8 -*-
"""
Created on Tue Jan  2 12:33:06 2018

@author: Utilisateur
n=100/p
r+s+m+e=1
r=(1-dt/n)*(1-m-e)
s=dt/n*(1-m-e)

X'(t)=f(X,t)=(X(t+dt)-X(t))/dt
"""
#import tkinter as tk
#from tkinter.filedialog import askopenfilename
#import matplotlib.pyplot as plt
#from mpl_toolkits.mplot3d.axes3d import Axes3D, get_test_data
#from matplotlib import cm
import numpy as np
#from time import time
#import psutil
#pid=os.getpid()
#ps=psutil.Process(pid)
#from tkinter import messagebox
#import pygame
#from pygame.locals import *
#from time import sleep
#import os
#import random
#import gc

#from modelediscret import *
hs=100000
def Euler(f,y0,t0,tf,n):
    h=abs(tf-t0)/(n-1)
    #n=1+abs(tf-t0)//dt
    t=np.linspace(t0,tf,n)
    Y=np.zeros((n,len(y0)))
    Y[0]=y0
    for i in range(n-1):
        Y[i+1,:]=Y[i,:]+h*f(Y[i,:],t[i])
    return t,Y

def ecartcontinu(dt,resultat,yliste2,fichierhomme,fichierfemme,populationinitiale,n,p,annee):
    arret=int(n*dt)+1
    a=True
    #t=np.linspace(0,n,hs)
    yliste2=[yliste2[int(i*(hs-1)/(dt*n))] for i in range(int(n*dt)+1)]
    resultat=[[resultat[int(i*(hs-1)/(dt*n))][j] for i in range(int(n*dt)+1)] for j in range(p*2)]
    colonne=populationinitiale[0].index(str(annee))
    ecarttot=[0 for i in range(int(n*dt)+1)]
    ecartrelatif=[[0 for i in range(int(n*dt)+1)] for j in range(p*2)]
    #initiale=[[0 for j in range(p)] for i in range(p)]
    for i in range(int(n*dt)+1):#complexité : O(p)
        try:
            tot=populationinitiale[1][colonne+i].replace(",",".").replace( "\xa0","").replace(" ","")
            ecarttot[i]=abs(float(tot)-yliste2[i])/float(tot)
        except:
            ecarttot[i]="pas d'info"
            if a:
                arret=i
                a=False
        #####
        nbfemme=[0 for x in range(100)]
        nbhomme=[0 for x in range(100)]
        for j in range(100-1):
            try:
                nbfemme[j]=float(fichierfemme[j+2][colonne+i].replace(",",".").replace( "\xa0","").replace(" ",""))
            except:
                nbfemme[j]=0
            try:
                nbhomme[j]=float(fichierhomme[j+2][colonne+i].replace(",",".").replace( "\xa0","").replace(" ",""))
            except:
                nbhomme[j]=0
        for j in range(100-1,len(populationinitiale)-2):
            try:
                nbfemme[100-1]+=float(fichierfemme[j+2][colonne+i].replace(",",".").replace( "\xa0","").replace(" ",""))
                nbhomme[100-1]+=float(fichierhomme[j+2][colonne+i].replace(",",".").replace( "\xa0","").replace(" ",""))
            except:
                pass

        y0=[0 for j in range(p*2)]
        for k in range(p):
            x1,x2=k*100//p,(k+1)*100//p
            if k==p-1:
                x2=100

            y0[2*k]=sum(nbhomme[x1:x2])
            y0[2*k+1]=sum(nbfemme[x1:x2])

        ######
        for j in range(2*p):#complexité : O(p)
            if float(y0[j])!=0:
                ecartrelatif[j][i]=abs(float(y0[j])-resultat[j][i])/float(y0[j])
            else:
                ecartrelatif[j][i]="pas d'info"


    return ecartrelatif,ecarttot,arret


def X_tplusdt(X,dt,fecondite,immigration,reste,survie,rencontre,logistique,K):
    matrice=[0 for i in range(len(X))]
    for i in range(len(matrice)):
        matrice[i]=(reste[i]+immigration[i])*X[i]+(survie[i-1]*X[i-1] if i>0 else 0)

    if rencontre:
        if logistique and K!=float("inf"):
            for j in range(len(X)//2):
                matrice[0]+=(fecondite[j]/2)*(X[2*j]*X[2*j+1]/(X[2*j]+X[2*j+1]))*((1-sum([X[i] for i in range(len(X))])/K) if K-sum([X[i] for i in range(len(X))])>0 else 0)
                matrice[1]+=(fecondite[j]/2)*(X[2*j]*X[2*j+1]/(X[2*j]+X[2*j+1]))*((1-sum([X[i] for i in range(len(X))])/K) if K-sum([X[i] for i in range(len(X))])>0 else 0)
        else:
            for j in range(len(X)//2):
                matrice[0]+=(fecondite[j]/2)*(X[2*j]*X[2*j+1]/(X[2*j]+X[2*j+1]))
                matrice[1]+=(fecondite[j]/2)*(X[2*j]*X[2*j+1]/(X[2*j]+X[2*j+1]))
    else:
        if logistique and K!=float("inf"):
            for j in range(len(X)//2):
                matrice[0]+=(fecondite[j]/2)*X[2*j+1]*((1-sum([X[i] for i in range(len(X))])/K) if K-sum([X[i] for i in range(len(X))])>0 else 0)
                matrice[1]+=(fecondite[j]/2)*X[2*j+1]*((1-sum([X[i] for i in range(len(X))])/K) if K-sum([X[i] for i in range(len(X))])>0 else 0)
        else:
            for j in range(len(X)//2):
                matrice[0]+=(fecondite[j]/2)*X[2*j+1]
                matrice[1]+=(fecondite[j]/2)*X[2*j+1]
    return matrice


def continu(dt,p,nbhomme,nbfemme,fec,mortalitehomme,mortalitefemme,immigrationhomme,immigrationfemme,emmigrationhomme,emmigrationfemme,n,annee,fichierpopulationinitiale,fichierhomme,fichierfemme,logistique=False,K=float("inf"),rencontre=True):
    assert K>sum(nbhomme)+sum(nbfemme),"!!! seuil dépassé initialement !!!"
    y0=[0 for i in range(p*2)]
    fecondite=[0 for i in range(p)]
    immigration=[0 for i in range(p*2)]
    reste=[0 for i in range(p*2)]
    survie=[0 for i in range(p*2)]
    mortalite=[0 for i in range(p*2)]
    emmigration=[0 for i in range(p*2)]
    for k in range(p):
        x1,x2=k*100//p,(k+1)*100//p
        if k==p-1:
            x2=100
        y0[2*k]=sum(nbhomme[x1:x2])
        y0[2*k+1]=sum(nbfemme[x1:x2])
        fecondite[k]=dt*sum([fec[i]*(nbhomme[i]+nbfemme[i])/nbfemme[i] for i in range(x1,x2)])/(x2-x1)*(((y0[2*k]+y0[2*k+1])/y0[2*k]) if rencontre else 1)*((1/(1-(sum(nbhomme)+sum(nbfemme))/K)) if logistique and K!=float("inf") else 1)
        immigration[2*k]=dt*sum([immigrationhomme[i] for i in range(x1,x2)])/(x2-x1)
        immigration[2*k+1]=dt*sum([immigrationfemme[i] for i in range(x1,x2)])/(x2-x1)
        mortalite[2*k]=sum([mortalitehomme[i] for i in range(x1,x2)])/(x2-x1)
        mortalite[2*k+1]=sum([mortalitefemme[i] for i in range(x1,x2)])/(x2-x1)
        emmigration[2*k]=sum([emmigrationhomme[i] for i in range(x1,x2)])/(x2-x1)
        emmigration[2*k+1]=sum([emmigrationfemme[i] for i in range(x1,x2)])/(x2-x1)
        reste[2*k]=dt*(1-p/100)*(1-mortalite[2*k]-emmigration[2*k])
        survie[2*k]=dt*(p/100)*(1-mortalite[2*k]-emmigration[2*k])
        reste[2*k+1]=dt*(1-p/100)*(1-mortalite[2*k+1]-emmigration[2*k+1])
        survie[2*k+1]=dt*(p/100)*(1-mortalite[2*k+1]-emmigration[2*k+1])

    f=lambda X,t:(X_tplusdt(X,dt,fecondite,immigration,reste,survie,rencontre,logistique,K)-X)/dt
    t,Y=Euler(f,y0,0,n,hs)
    #
    yliste2=[0 for i in range(len(Y))]
    for i in range(len(Y)):
        yliste2[i]=sum([Y[i,j] for j in range(len(Y[i]))])
    #
    matrice=[[Y[len(Y)-1,i]] for i in range(len(Y[0]))]
    #
    #print(t)
    ecartliste,ecartlistetot,arret=ecartcontinu(dt,Y,yliste2,fichierhomme,fichierfemme,fichierpopulationinitiale,n,p,annee)
    return matrice,np.transpose(Y),yliste2,ecartliste,ecartlistetot,arret
